SystemOrganization addCategory: #'Volunti-PollingOffice-Model'!
SystemOrganization addCategory: #'Volunti-PollingOffice-View'!

VOManager subclass: #VOPollingOfficeManager
	instanceVariableNames: 'pollingoffices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-PollingOffice-Model'!

!VOPollingOfficeManager class methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/11/2011 14:06'!
organisationUnit
	^ 'Polling Office'! !

!VOPollingOfficeManager class methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/1/2011 09:24'!
port
	^ 1256! !

!VOPollingOfficeManager methodsFor: 'phases' stamp: 'NicolasVanderAuwera 7/30/2012 15:03'!
auditionPhase
	| authority id |
	authority := self authorityWithId: stream nextLine greaseInteger.
	authority auditingOn: stream.
	self addInLog: 'Auditing phase.'! !

!VOPollingOfficeManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/19/2012 09:03'!
authorityClass
	^ VOPollingOffice! !

!VOPollingOfficeManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 15:09'!
authorityFor: aProtocol
	aProtocol isMentalBooth
		ifTrue: [ ^ VOCompletePollingOffice ].
	aProtocol isAlternative
		ifTrue: [ ^ VOAlternativePollingOffice ].
	^ VOSimplePollingOffice! !

!VOPollingOfficeManager methodsFor: 'phases' stamp: 'NicolasVanderAuwera 7/30/2012 15:06'!
castingPhase
	| authority id |
	authority := self authorityWithId: self idOnStream.
	authority addBallot: stream receiveObject.
	stream sendCommand: 'success'.
	self addInLog: 'A vote has been correctly casted.'! !

!VOPollingOfficeManager methodsFor: 'testing' stamp: 'NicolasVanderAuwera 7/27/2012 08:00'!
checkUser
	| subAgent |
	subAgent := self authorityWithId: self idOnStream.
	stream sendCommand: (subAgent isVoterAlreadyVoted: stream nextLine greaseInteger) greaseString! !

!VOPollingOfficeManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/7/2012 14:14'!
handle: aSymbol
	super handle: aSymbol.
	aSymbol = #ballots
		ifTrue: [ self votingPhase ].
	aSymbol = #audit
		ifTrue: [ self auditionPhase ].
	aSymbol = #cast
		ifTrue: [ self castingPhase ].
	aSymbol = #checkuser
		ifTrue: [ self checkUser ].
	aSymbol = #unusedshares
		ifTrue: [ self sendUnusedShares ].
	aSymbol = #results
		ifFalse: [ ^ self ].
	self sendResults! !

!VOPollingOfficeManager methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/5/2012 14:20'!
initialize
	| generator |
	super initialize.
	generator := RSAKeyPairGenerator bits: 1024.
	publicKey := generator publicKey.
	privateKey := generator privateKey! !

!VOPollingOfficeManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/30/2012 15:02'!
sendResults
	stream sendObject: self authorityOnStream calculateResult.
	self addInLog: 'Results send'! !

!VOPollingOfficeManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/30/2012 15:02'!
sendUnusedShares
	stream sendObject: self authorityOnStream unusedShares.
	self addInLog: 'Unused shares are send to the Public Board.'! !

!VOPollingOfficeManager methodsFor: 'phases' stamp: 'NicolasVanderAuwera 7/23/2012 07:48'!
votingPhase
	| subagent id |
	subagent := self authorityWithId: stream nextLine greaseInteger.
	subagent votingPhaseOn: stream! !

VOAgentComponent subclass: #VOPollingOfficeComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-PollingOffice-View'!

!VOPollingOfficeComponent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/27/2011 13:26'!
url
	^ 'pollingoffice'! !

!VOPollingOfficeComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
agentClass
	^ VOPollingOfficeManager! !

!VOPollingOfficeComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/25/2012 10:23'!
buildMainComponent
	^ VOManagerMainComponent agent: self agent! !

!VOPollingOfficeComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/27/2011 09:36'!
title
	^ 'Polling Office'! !

VOAuthority subclass: #VOPollingOffice
	instanceVariableNames: 'urn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-PollingOffice-Model'!

VOPollingOffice subclass: #VOCompletePollingOffice
	instanceVariableNames: 'paillierPk paillierShares numberOfBallots sharesUsed tokens publicKey voterIds savedBallots thresholdPublicKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-PollingOffice-Model'!

VOCompletePollingOffice subclass: #VOAlternativePollingOffice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-PollingOffice-Model'!

!VOAlternativePollingOffice methodsFor: 'process' stamp: 'NicolasVanderAuwera 8/25/2012 08:02'!
decrypt: votes with: voterId
	1 to: votes size do: [ :i | 
		(self hasTokenWithId: voterId andKey: (votes at: i) asByteArray asInteger)
			ifTrue: [ votes at: i put: 1 ]
			ifFalse: [ votes at: i put: 0 ] ].
	^ votes! !

!VOAlternativePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/23/2012 10:27'!
encryptBallot: ballot
	| plainVotes paillierShare encryptedVotes c cprim r tuples |
	paillierShare := paillierShares removeFirst.
	plainVotes := self decrypt: ballot votes with: ballot voterId.
	tuples := plainVotes
		collect: [ :vote | 
			c := self thresholdPublicKey crypt: vote asByteArray asInteger.
			r := self thresholdPublicKey r.
			cprim := paillierShare blind: c with: self thresholdPublicKey.
			VOVoteTuple plain: vote encrypt: cprim r: r ].
	^ VOVoteContainer tuples: tuples share: paillierShare id: ballot voterId! !

!VOCompletePollingOffice methodsFor: 'phases' stamp: 'NicolasVanderAuwera 5/9/2012 09:57'!
auditingOn: aStream
	| position vcCollection voterId ballotsToSend |
	position := aStream nextLine greaseInteger.
	voterId := aStream nextLine greaseInteger.
	ballotsToSend := OrderedCollection new.
	vcCollection := savedBallots at: voterId.
	vcCollection
		keysAndValuesDo: [ :i :vc | 
			i = position
				ifFalse: [ 
					ballotsToSend add: vc.
					sharesUsed add: vc share ] ].
	self assert: ballotsToSend size = (vcCollection size - 1).
	aStream sendObject: ballotsToSend! !

!VOCompletePollingOffice methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 8/5/2012 14:08'!
castBallot: aBallot
	self addBallot: aBallot.
	voterIds add: aBallot voterId.
	self sendProofOf: aBallot! !

!VOCompletePollingOffice methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 5/6/2012 14:56'!
close
	super close.
	self sendUrn! !

!VOCompletePollingOffice methodsFor: 'phases' stamp: 'NicolasVanderAuwera 5/7/2012 13:52'!
collectingVotesOn: aStream
	| collection |
	collection := aStream receiveObject collect: [ :ballot | self encryptBallot: ballot ].
	savedBallots at: collection first id put: collection.
	^ collection! !

!VOCompletePollingOffice methodsFor: 'process' stamp: 'NicolasVanderAuwera 8/25/2012 08:01'!
decrypt: votes with: voterId
	1 to: votes size do: [ :i | 
		(self hasTokenWithId: voterId andKey: (votes at: i))
			ifTrue: [ votes at: i put: 1 ]
			ifFalse: [ votes at: i put: 0 ] ].
	^ votes! !

!VOCompletePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/18/2012 07:52'!
encryptBallot: ballot
	| plainVotes paillierShare encryptedVotes c cprim r tuples |
	paillierShare := paillierShares removeFirst.
	plainVotes := self decrypt: ballot votes with: ballot voterId.
	tuples := plainVotes
		collect: [ :vote | 
			c := self thresholdPublicKey crypt: vote.
			r := self thresholdPublicKey r.
			cprim := paillierShare blind: c with: self thresholdPublicKey.
			VOVoteTuple plain: vote encrypt: cprim r: r ].
	^ VOVoteContainer tuples: tuples share: paillierShare id: ballot voterId! !

!VOCompletePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/18/2012 07:49'!
hasTokenWithId: anInteger andKey: aKey
	^ tokens anySatisfy: [ :token | token id = anInteger and: [ token secret = aKey ] ]! !

!VOCompletePollingOffice methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/9/2012 08:36'!
initialize
	super initialize.
	sharesUsed := OrderedCollection new.
	savedBallots := Dictionary new! !

!VOCompletePollingOffice methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/7/2012 11:46'!
isVoterAlreadyVoted: anUid
	^ self voterIds includes: anUid! !

!VOCompletePollingOffice methodsFor: 'public' stamp: 'NicolasVanderAuwera 5/7/2012 11:13'!
open
	super open.
	self requestTokens.
	self requestShares! !

!VOCompletePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/25/2012 09:30'!
requestShares
	| client homomorphicAuth |
	homomorphicAuth := self configurations at: VOHomomorphicManager key.
	client := SocketStream openConnectionToHostNamed: homomorphicAuth host port: homomorphicAuth port.
	client
		sendCommand: #shares;
		sendCommand: id greaseString;
		sendCommand: self tokens size greaseString.
	paillierShares := client receiveObject asOrderedCollection.
	client close! !

!VOCompletePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/23/2012 07:38'!
requestThresholdPublicKey
	| client homomorphicAuth |
	homomorphicAuth := self configurations at: VOHomomorphicManager key.
	client := SocketStream openConnectionToHostNamed: homomorphicAuth host port: homomorphicAuth port.
	client
		sendCommand: 'thresholdpublickey';
		sendCommand: id greaseString.
	thresholdPublicKey := client receiveObject.
	client close! !

!VOCompletePollingOffice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
requestTokens
	| client mbAuthority |
	mbAuthority := self configurations at: VOMentalBoothManager key.
	client := SocketStream openConnectionToHostNamed: mbAuthority host port: mbAuthority port.
	client
		sendCommand: #tokens;
		sendCommand: id greaseString.
	tokens := client receiveObject.
	client close! !

!VOCompletePollingOffice methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
sendProofOf: aBallot
	| client publicBoard |
	publicBoard := self configurations at: VOPublicBoardManager key.
	client := SocketStream openConnectionToHostNamed: publicBoard host port: publicBoard port.
	client
		sendCommand: #proof;
		sendCommand: id greaseString;
		sendCommand: aBallot voterId greaseString;
		sendObject: aBallot votes.
	client close! !

!VOCompletePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
sendUrn
	| stream publicBoard |
	publicBoard := self configurations at: VOPublicBoardManager key.
	urn id: self id.
	stream := SocketStream openConnectionToHostNamed: publicBoard host port: publicBoard port.
	stream sendCommand: #urn.
	stream sendCommand: id greaseString.
	stream sendObject: urn.
	stream close! !

!VOCompletePollingOffice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/9/2012 12:51'!
thresholdPublicKey
	thresholdPublicKey ifNil: [ self requestThresholdPublicKey ].
	^ thresholdPublicKey! !

!VOCompletePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 4/9/2012 13:26'!
tokenWithId: anInteger
	^ tokens detect: [ :token | token id = anInteger ] ifNone: [ nil ]! !

!VOCompletePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/18/2012 07:48'!
tokenWithId: anInteger andKey: aKey
	^ tokens detect: [ :token | token id = anInteger and: [ token secret = aKey ] ] ifNone: [ nil ]! !

!VOCompletePollingOffice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 13:40'!
tokens
	tokens ifNil: [ self requestTokens ].
	^ tokens! !

!VOCompletePollingOffice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/25/2012 07:34'!
unusedShares
	"opened
		ifFalse: [ self error: 'The election must be close.' ]."
	^ paillierShares , sharesUsed! !

!VOCompletePollingOffice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 11:45'!
voterIds
	voterIds ifNil: [ voterIds := SortedCollection new ].
	^ voterIds! !

!VOCompletePollingOffice methodsFor: 'phases' stamp: 'NicolasVanderAuwera 5/9/2012 08:35'!
votingPhaseOn: aStream
	| voteContainers vote |
	aStream noTimeout.
	voteContainers := self collectingVotesOn: aStream.
	aStream sendObject: (voteContainers collect: [ :vc | vc encryptedVotes ])! !

!VOPollingOffice class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 11/20/2012 15:04'!
newFrom: anElection
	^ self new
		name: anElection name;
		id: anElection id;
		yourself! !

!VOPollingOffice methodsFor: 'adding' stamp: 'NicolasVanderAuwera 5/6/2012 14:55'!
addBallot: ballot
	urn addBallot: ballot! !

!VOPollingOffice methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/6/2012 14:44'!
initialize
	super initialize.
	urn := VOUrn new! !

!VOPollingOffice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 13:56'!
urn
	^ urn! !

!VOPollingOffice methodsFor: 'phases' stamp: 'NicolasVanderAuwera 5/6/2012 14:44'!
votingPhaseOn: aStream
	self subclassResponsibility! !

VOPollingOffice subclass: #VOSimplePollingOffice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-PollingOffice-Model'!

!VOSimplePollingOffice methodsFor: 'process' stamp: 'NicolasVanderAuwera 5/5/2012 10:07'!
calculateResult
	| results |
	urn numberOfChoices isZero
		ifTrue: [ ^ Array with: 0 ].
	results := (1 to: urn numberOfChoices) collect: [ :i | 0 ].
	urn ballots do: [ :ballot | results := results + ballot votes ].
	^ results collect: [ :result | (result * 100 / urn tally) asFloat ]! !

!VOSimplePollingOffice methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 5/6/2012 14:57'!
close
	super close.
	urn := nil! !

!VOSimplePollingOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/5/2012 09:45'!
votingPhaseOn: aStream
	self addBallot: aStream receiveObject! !

Object subclass: #VOVoteContainer
	instanceVariableNames: 'share id tuples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-PollingOffice-Model'!

!VOVoteContainer class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/7/2012 09:06'!
tuples: aTuple share: s id: i
	^ self new
		tuples: aTuple;
		share: s;
		id: i;
		yourself! !

!VOVoteContainer methodsFor: 'converting' stamp: 'NicolasVanderAuwera 8/23/2012 13:46'!
asXML
	| xml |
	xml := XMLWriter on: (WriteStream on: String new).
	xml
		startTag: 'ballot';
		endTag.
	xml
		startTag: 'share';
		endTag.
	xml
		startTag: 'bki';
		endTag.
	xml writeXmlEncoded: share bki greaseString.
	xml
		startTag: '/bki';
		endTag.
	xml
		startTag: 'exponent';
		endTag.
	xml writeXmlEncoded: share exponent greaseString.
	xml
		startTag: '/exponent';
		endTag.
	xml
		startTag: '/share';
		endTag.
	xml
		startTag: 'votes';
		endTag.
	tuples do: [ :tuple | xml writeXmlEncoded: tuple asXML ].
	xml
		startTag: '/votes';
		endTag.
	xml
		startTag: '/ballot';
		endTag.
	^ xml stream contents! !

!VOVoteContainer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:10'!
encryptedVotes
	^ tuples collect: [ :tuple | tuple encrypt ]! !

!VOVoteContainer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 14:34'!
id
	^ id! !

!VOVoteContainer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 14:34'!
id: anObject
	id := anObject! !

!VOVoteContainer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 14:10'!
share
	^ share! !

!VOVoteContainer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 14:10'!
share: anObject
	share := anObject! !

!VOVoteContainer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:06'!
tuples
	^ tuples! !

!VOVoteContainer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:06'!
tuples: aTuple
	tuples := aTuple! !

Object subclass: #VOVoteTuple
	instanceVariableNames: 'plain encrypt r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-PollingOffice-Model'!

!VOVoteTuple class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/7/2012 11:33'!
plain: vote encrypt: c r: anInteger
	^ self new
		plain: vote;
		encrypt: c;
		r: anInteger;
		yourself! !

!VOVoteTuple methodsFor: 'converting' stamp: 'NicolasVanderAuwera 8/20/2012 08:16'!
asXML
	| xml |
	xml := XMLWriter on: (WriteStream on: String new).
	xml
		startTag: 'vote';
		endTag.
	xml
		startTag: 'encrypt';
		endTag.
	xml writeXmlEncoded: encrypt greaseString.
	xml
		startTag: '/encrypt';
		endTag.
	xml
		startTag: 'plain';
		endTag.
	xml writeXmlEncoded: plain greaseString.
	xml
		startTag: '/plain';
		endTag.
	xml
		startTag: 'random';
		endTag.
	xml writeXmlEncoded: r greaseString.
	xml
		startTag: '/random';
		endTag.
	xml
		startTag: '/vote';
		endTag.
	^ xml stream contents! !

!VOVoteTuple methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:03'!
encrypt
	^ encrypt! !

!VOVoteTuple methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:03'!
encrypt: anObject
	encrypt := anObject! !

!VOVoteTuple methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:03'!
plain
	^ plain! !

!VOVoteTuple methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:03'!
plain: anObject
	plain := anObject! !

!VOVoteTuple methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:03'!
r
	^ r! !

!VOVoteTuple methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:03'!
r: anObject
	r := anObject! !
